type t = { mutable cchar: char option; 
	   mutable line: int;
	   mutable column: int;
	   in_channel : in_channel }

let read_char o = 
  try Some(Pervasives.input_char o.in_channel)
  with End_of_file -> None

let next_char o =
  begin
    match o.cchar with
      | None -> ()
      | Some('\n') ->
	  o.column <- 0;
	  o.line <- o.line + 1
      | _ ->
	  o.column <- o.column + 1
  end;
  o.cchar <- read_char o

let current_char o = o.cchar

let get_position o = o.line,o.column

let charReader_of_in_channel c =
  let o = { cchar = Some ' ';
	    line = 1;
	    column = -1;
	    in_channel = c
	  }
  in
    next_char o;
    o

